'use strict';

var bl = require("bl");
var through2 = require("through2");
var debug = require("debug")("through2-buffer");

module.exports = function (bufferSize) {
	var buff = bl();
	var flowing = false;

	return through2(function (chunk, encoding, cb) {
		if (flowing) {
			this.push(chunk);
		} else {
			debug("Buffering chunk of size " + chunk.length);
			buff.append(chunk);
			debug("Buffer length now " + buff.length);

			if (buff.length >= bufferSize) {
				debug("Buffer limit reached; setting to flowing mode");
				flowing = true;
				this.push(buff.read(buff.length));
			}
		}

		cb();
	});
};